searchNodes=[{"doc":"Membrane element that decodes video in H264 format. It is backed by decoder from FFmpeg. The element expects the data for each frame (Access Unit) to be received in a separate buffer, so the parser ( Membrane.H264.FFmpeg.Parser ) may be required in a pipeline before decoder (e.g. when input is read from Membrane.File.Source ). Element options Passed via struct Membrane.H264.FFmpeg.Decoder.t/0 use_shm? boolean ( ) Default value: false Pads :input Accepted formats %H264{alignment: :au} Availability :always Demand mode :auto Demand unit :buffers Direction :input Mode :pull Name :input :output Accepted formats %RawVideo{pixel_format: format, aligned: true} when format in [:I420, :I422] Availability :always Demand mode :auto Direction :output Mode :pull Name :output","ref":"Membrane.H264.FFmpeg.Decoder.html","title":"Membrane.H264.FFmpeg.Decoder","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.H264.FFmpeg.Decoder.html#options/0","title":"Membrane.H264.FFmpeg.Decoder.options/0","type":"function"},{"doc":"Struct containing options for Membrane.H264.FFmpeg.Decoder","ref":"Membrane.H264.FFmpeg.Decoder.html#t:t/0","title":"Membrane.H264.FFmpeg.Decoder.t/0","type":"type"},{"doc":"Membrane element that encodes raw video frames to H264 format. The element expects each frame to be received in a separate buffer, so the parser ( Membrane.Element.RawVideo.Parser ) may be required in a pipeline before the encoder (e.g. when input is read from Membrane.File.Source ). Additionally, the encoder has to receive proper stream_format with picture format and dimensions before any encoding takes place. Please check t/0 for available options. Element options Passed via struct Membrane.H264.FFmpeg.Encoder.t/0 crf 0 .. 63 Default value: 23 Constant rate factor that affects the quality of output stream. Value of 0 is lossless compression while 51 (for 8-bit samples) or 63 (10-bit) offers the worst quality. The range is exponential, so increasing the CRF value +6 results in roughly half the bitrate / file size, while -6 leads to roughly twice the bitrate. preset preset ( ) Default value: :medium Collection of predefined options providing certain encoding. The slower the preset chosen, the higher compression for the same quality can be achieved. profile H264 . profile_t ( ) | nil Default value: nil Sets a limit on the features that the encoder will use to the ones supported in a provided H264 profile. Said features will have to be supported by the decoder in order to decode the resulting video. It may override other, more specific options affecting compression (e.g setting max_b_frames to 2 while profile is set to :baseline will have no effect and no B-frames will be present). use_shm? boolean ( ) Default value: false max_b_frames non_neg_integer ( ) | nil Default value: nil Maximum number of B-frames between non-B-frames. Set to 0 to encode video without b-frames gop_size non_neg_integer ( ) | nil Default value: nil Number of frames in a group of pictures. Pads :input Accepted formats %RawVideo{pixel_format: format, aligned: true} when format in [:I420, :I422] Availability :always Demand mode :auto Demand unit :buffers Direction :input Mode :pull Name :input :output Accepted formats %H264{alignment: :au} Availability :always Demand mode :auto Direction :output Mode :pull Name :output","ref":"Membrane.H264.FFmpeg.Encoder.html","title":"Membrane.H264.FFmpeg.Encoder","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.H264.FFmpeg.Encoder.html#options/0","title":"Membrane.H264.FFmpeg.Encoder.options/0","type":"function"},{"doc":"","ref":"Membrane.H264.FFmpeg.Encoder.html#t:preset/0","title":"Membrane.H264.FFmpeg.Encoder.preset/0","type":"type"},{"doc":"Struct containing options for Membrane.H264.FFmpeg.Encoder","ref":"Membrane.H264.FFmpeg.Encoder.html#t:t/0","title":"Membrane.H264.FFmpeg.Encoder.t/0","type":"type"},{"doc":"Membrane element providing parser for H264 encoded video stream. Uses the parser provided by FFmpeg. By default, this parser splits the stream into h264 access units, each of which is a sequence of NAL units corresponding to one video frame, and equips them with the following metadata entries under :h264 key: key_frame?: boolean - determines whether the frame is a h264 I frame. Setting custom packetization options affects metadata, see alignment and attach_nalus? options for details. This Parser is also capable of handling out-of-band parameters in the form of Decoder Configuration Record. To inject it, simply send Membrane.H264.RemoteStream.t/0 stream_format containing the Decoder Configuration Record to this element. There are however some limitations: Membrane.H264.RemoteStream.t/0 stream_format needs to be send only before the first buffer. Sending them during the stream will cause an error SPS and PPS will be extracted from Decoder Configuration Record and added to the payload of the very first buffer without any checks of in-band parameters. This might result in duplicated SPS and PPS. It shouldn't be a problem, unless you send an incorrect Decoder Configuration Record that doesn't match the stream. Element options Passed via struct Membrane.H264.FFmpeg.Parser.t/0 framerate H264 . framerate_t ( ) | nil Default value: nil Framerate of video stream, see Membrane.H264.framerate_t/0 sps binary ( ) Default value: &quot;&quot; Sequence Parameter Set NAL unit - if absent in the stream, should be provided via this option. pps binary ( ) Default value: &quot;&quot; Picture Parameter Set NAL unit - if absent in the stream, should be provided via this option. alignment :au | :nal Default value: :au Stream units carried by each output buffer. See Membrane.H264.alignment_t/0 . If alignment is :nal , the following metadata entries are added: type - h264 nalu type new_access_unit: access_unit_metadata - added whenever the new access unit starts. access_unit_metadata is the metadata that would be merged into the buffer metadata normally (if alignment was :au ). end_access_unit: true - added for each NALu that ends an access unit. attach_nalus? boolean ( ) Default value: false Determines whether to attach NAL units list to the metadata when alignment option is set to :au . For details see Membrane.H264.nalu_in_metadata_t/0 . skip_until_keyframe? boolean ( ) Default value: false Determines whether to drop the stream until the first key frame is received. skip_until_parameters? boolean ( ) Default value: true Determines whether to drop the stream until the first set of SPS and PPS is received. max_frame_reorder non_neg_integer ( ) Default value: 15 Defines the maximum expected number of consequent b-frames in the stream. Pads :input Accepted formats %format{} when format in [Membrane.RemoteStream, H264.RemoteStream] Availability :always Demand mode :auto Demand unit :buffers Direction :input Mode :pull Name :input :output Accepted formats %H264{} Availability :always Demand mode :auto Direction :output Mode :pull Name :output","ref":"Membrane.H264.FFmpeg.Parser.html","title":"Membrane.H264.FFmpeg.Parser","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.H264.FFmpeg.Parser.html#options/0","title":"Membrane.H264.FFmpeg.Parser.options/0","type":"function"},{"doc":"Struct containing options for Membrane.H264.FFmpeg.Parser","ref":"Membrane.H264.FFmpeg.Parser.html#t:t/0","title":"Membrane.H264.FFmpeg.Parser.t/0","type":"type"},{"doc":"Utility functions for parsing AVC Configuration Record","ref":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.html","title":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration","type":"module"},{"doc":"","ref":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.html#parse/1","title":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.parse/1","type":"function"},{"doc":"","ref":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.html#t:t/0","title":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.t/0","type":"type"},{"doc":"This package provides H264 video parser, decoder and encoder, based on ffmpeg and x264 . It is a part of the Membrane Multimedia Framework Documentation is available at HexDocs","ref":"readme.html","title":"Membrane H264 FFmpeg plugin","type":"extras"},{"doc":"Add the following line to your deps in mix.exs . Run mix deps.get . { :membrane_h264_ffmpeg_plugin , &quot;~&gt; 0.25.1&quot; } You also need to have ffmpeg libraries installed in your system. Ubuntu sudo apt-get install libavcodec-dev libavformat-dev libavutil-dev Arch/Manjaro pacman -S ffmpeg MacOS brew install ffmpeg","ref":"readme.html#installation","title":"Membrane H264 FFmpeg plugin - Installation","type":"extras"},{"doc":"Decoder The following pipeline takes 30fps H264 file and decodes it to the raw video. defmodule Decoding.Pipeline do use Membrane.Pipeline @impl true def handle_init ( _ctx , _opts ) do structure = child ( :source , % Membrane.File.Source { chunk_size : 40_960 , location : &quot;input.h264&quot; } ) |&gt; child ( :parser , % H264.FFmpeg.Parser { framerate : { 30 , 1 } } ) |&gt; child ( :decoder , H264.FFmpeg.Decoder ) |&gt; child ( :sink , % Membrane.File.Sink { location : &quot;output.raw&quot; } ) { [ spec : structure ] , %{ } } end end Encoder The following pipeline takes 720p raw video file as input and encodes it as H264. defmodule Encoding.Pipeline do use Membrane.Pipeline @impl true def handle_init ( _ ) do structure = child ( :source , % Membrane.File.Source { chunk_size : 40_960 , location : &quot;input.raw&quot; } ) |&gt; child ( :parser , % Membrane.RawVideo.Parser { width : 1280 , height : 720 , pixel_format : :I420 } ) |&gt; child ( :encoder , % Membrane.H264.FFmpeg.Encoder { preset : :fast , crf : 30 } ) |&gt; child ( :sink , % Membrane.File.Sink { location : &quot;output.h264&quot; } ) { [ spec : structure ] , %{ } } end end","ref":"readme.html#usage-example","title":"Membrane H264 FFmpeg plugin - Usage Example","type":"extras"},{"doc":"Copyright 2018, Software Mansion","ref":"readme.html#copyright-and-license","title":"Membrane H264 FFmpeg plugin - Copyright and License","type":"extras"}]